<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: io/writefemavs.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_7dc76e12c3f74bb85b7effb3b7dc07e4.html">io</a>
  </div>
</div>
<div class="contents">
<h1>writefemavs.c</h1><a href="writefemavs_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: writefemavs.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">magpario.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define NVDATA  10</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00033"></a><a class="code" href="writefemavs_8c.html#ad28639d44673a3d4c835d2390bf74c29">00033</a> <span class="preprocessor"></span><span class="preprocessor">#define NVDATA  4</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00035"></a><a class="code" href="writefemavs_8c.html#ae821231396164e33ec42f01e154f5e3c">00035</a> <span class="preprocessor"></span><span class="preprocessor">#define NEDATA  11</span>
<a name="l00036"></a><a class="code" href="writefemavs_8c.html#a36b5a0a7c9d9a2c0e0060a859ae15269">00036</a> <span class="preprocessor"></span><span class="preprocessor">#define NEDATA2 0</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a><a class="code" href="writefemavs_8c.html#aee403d14a781f164b0e81a247fe8df92">00038</a> <span class="preprocessor">#define D_FLT 50</span>
<a name="l00039"></a><a class="code" href="writefemavs_8c.html#acbf9b17358605863de9e2c1a5b802e53">00039</a> <span class="preprocessor"></span><span class="preprocessor">#define D_EID 8</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00044"></a><a class="code" href="writefemavs_8c.html#afcfe52b023f7bd7762b109bea3096cfc">00044</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keywordtype">int</span> rank,size;
<a name="l00049"></a>00049   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00050"></a>00050   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="keywordtype">char</span> fmesh[256];
<a name="l00053"></a>00053 <span class="preprocessor">#if defined(ZLIB) &amp;&amp; !defined(_WIN32) &amp;&amp; !defined(__CYGWIN32__)</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>  ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s.%04i.%s&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>,<span class="stringliteral">&quot;femsh&quot;</span>);CHKERRQ(ierr);
<a name="l00055"></a>00055 <span class="preprocessor">#else</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>  ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s.%04i.%s&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>,<span class="stringliteral">&quot;femsh.inp&quot;</span>);CHKERRQ(ierr);
<a name="l00057"></a>00057 <span class="preprocessor">#endif</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span>  FILE *fd;
<a name="l00059"></a>00059   ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;w&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00060"></a>00060   <span class="keywordflow">if</span> (!rank &amp;&amp; !fd) {
<a name="l00061"></a>00061     SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00062"></a>00062   }
<a name="l00063"></a>00063   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="preprocessor">#if defined(ZLIB) &amp;&amp; !defined(_WIN32) &amp;&amp; !defined(__CYGWIN32__)</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>  ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;%i %i ??? ??? ???\n&quot;</span>,
<a name="l00067"></a>00067     gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);CHKERRQ(ierr);
<a name="l00068"></a>00068 <span class="preprocessor">#else</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>  ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;%i %i %i %i %i\n&quot;</span>,
<a name="l00070"></a>00070     gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,<a class="code" href="writedatadat_8c.html#ad28639d44673a3d4c835d2390bf74c29">NVDATA</a>,<a class="code" href="writedataavs_8c.html#ae821231396164e33ec42f01e154f5e3c">NEDATA</a>,0);CHKERRQ(ierr);
<a name="l00071"></a>00071 <span class="preprocessor">#endif</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>
<a name="l00073"></a>00073   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00074"></a>00074     ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00075"></a>00075       <span class="stringliteral">&quot;%i %g %g %g\n&quot;</span>,
<a name="l00076"></a>00076       i+1,
<a name="l00077"></a>00077       PetscRealPart(gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0]),
<a name="l00078"></a>00078       PetscRealPart(gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1]),
<a name="l00079"></a>00079       PetscRealPart(gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2])
<a name="l00080"></a>00080     );CHKERRQ(ierr);
<a name="l00081"></a>00081   }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="keywordtype">char</span> *wbufs,*wbufe;
<a name="l00084"></a>00084   <span class="keywordtype">int</span> nmax;
<a name="l00085"></a>00085   <span class="comment">/* add 1 so we allocate at least once char even if gdata-&gt;ln_ele==0 */</span>
<a name="l00086"></a>00086   nmax=gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>*(<a class="code" href="writedataavs_8c.html#acbf9b17358605863de9e2c1a5b802e53">D_EID</a>+6*<a class="code" href="writedataavs_8c.html#aee403d14a781f164b0e81a247fe8df92">D_FLT</a>)+1;
<a name="l00087"></a>00087   ierr = PetscMalloc(nmax*<span class="keyword">sizeof</span>(<span class="keywordtype">char</span>),&amp;wbufs);CHKERRQ(ierr);
<a name="l00088"></a>00088   wbufe=wbufs;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>; i++) {
<a name="l00091"></a>00091     <span class="keywordtype">int</span> nchars;
<a name="l00092"></a>00092     <span class="comment">/* write into buffer */</span>
<a name="l00093"></a>00093     nchars=
<a name="l00094"></a>00094     snprintf(
<a name="l00095"></a>00095       wbufe,
<a name="l00096"></a>00096       nmax-(wbufe-wbufs),
<a name="l00097"></a>00097       <span class="stringliteral">&quot;%i %i tet %i %i %i %i\n&quot;</span>,
<a name="l00098"></a>00098       gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i]+1,
<a name="l00099"></a>00099       gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+1,
<a name="l00100"></a>00100       gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+0]+1,
<a name="l00101"></a>00101       gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+1]+1,
<a name="l00102"></a>00102       gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+2]+1,
<a name="l00103"></a>00103       gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+3]+1
<a name="l00104"></a>00104     );
<a name="l00105"></a>00105     <span class="comment">/* check for problems of snprintf */</span>
<a name="l00106"></a>00106     assert(nchars&gt;0);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108     <span class="comment">/* update pointer to the end of the array */</span>
<a name="l00109"></a>00109     wbufe += nchars;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111     <span class="comment">/* check if we write beyond allocated area */</span>
<a name="l00112"></a>00112     assert(wbufe-wbufs &lt; nmax);
<a name="l00113"></a>00113   }
<a name="l00114"></a>00114   <a class="code" href="syncffprintf_8c.html#ad822d6c23d995cdca14184e56d559423">SynchronizedFastFPrintf</a>(fd,wbufe-wbufs,nmax,wbufs,PETSC_FALSE);
<a name="l00115"></a>00115   wbufe=wbufs;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#if defined(ZLIB) &amp;&amp; !defined(_WIN32) &amp;&amp; !defined(__CYGWIN32__)</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>  ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s.%04i.%s&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>,<span class="stringliteral">&quot;fedat&quot;</span>);CHKERRQ(ierr);
<a name="l00122"></a>00122   ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;w&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00123"></a>00123   <span class="keywordflow">if</span> (!rank &amp;&amp; !fd) {
<a name="l00124"></a>00124     SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00125"></a>00125   }
<a name="l00126"></a>00126   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00127"></a>00127 <span class="preprocessor">#endif</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>
<a name="l00129"></a>00129   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;%i&quot;</span>,<a class="code" href="writedatadat_8c.html#ad28639d44673a3d4c835d2390bf74c29">NVDATA</a>);CHKERRQ(ierr);
<a name="l00130"></a>00130   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="writedatadat_8c.html#ad28639d44673a3d4c835d2390bf74c29">NVDATA</a>;i++) {
<a name="l00131"></a>00131     ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot; 1&quot;</span>);CHKERRQ(ierr);
<a name="l00132"></a>00132   }
<a name="l00133"></a>00133   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;\n&quot;</span>);CHKERRQ(ierr);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;id, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00136"></a>00136   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;vert_vol, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00137"></a>00137   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;vert_pid, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00138"></a>00138   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;proc, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00139"></a>00139 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>  ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;H1x, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00141"></a>00141   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;H1y, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00142"></a>00142   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;H1z, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00143"></a>00143   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;H2x, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00144"></a>00144   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;H2y, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00145"></a>00145   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;H2z, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00146"></a>00146 <span class="preprocessor">#endif</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span>
<a name="l00148"></a>00148   PetscReal *ta_vvol;
<a name="l00149"></a>00149   VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,&amp;ta_vvol);
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>  PetscReal *ta_vh1;
<a name="l00153"></a>00153   PetscReal *ta_vh2;
<a name="l00154"></a>00154   <span class="keywordflow">if</span> (gdata-&gt;VH1!=PETSC_NULL) {
<a name="l00155"></a>00155     VecGetArray(gdata-&gt;VH1,&amp;ta_vh1);
<a name="l00156"></a>00156   }
<a name="l00157"></a>00157   <span class="keywordflow">if</span> (gdata-&gt;VH2!=PETSC_NULL) {
<a name="l00158"></a>00158     VecGetArray(gdata-&gt;VH2,&amp;ta_vh2);
<a name="l00159"></a>00159   }
<a name="l00160"></a>00160 <span class="preprocessor">#endif</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>
<a name="l00162"></a>00162   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00163"></a>00163     <span class="keywordtype">int</span> nchars;
<a name="l00164"></a>00164     <span class="comment">/* write into buffer */</span>
<a name="l00165"></a>00165     nchars=
<a name="l00166"></a>00166     snprintf(
<a name="l00167"></a>00167       wbufe,
<a name="l00168"></a>00168       nmax-(wbufe-wbufs),
<a name="l00169"></a>00169       <span class="stringliteral">&quot;%i %i %g %i %i&quot;</span>,
<a name="l00170"></a>00170       gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]+1,
<a name="l00171"></a>00171       gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]+1,
<a name="l00172"></a>00172       ta_vvol[i],
<a name="l00173"></a>00173       gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i],
<a name="l00174"></a>00174       rank
<a name="l00175"></a>00175     );
<a name="l00176"></a>00176 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00177"></a>00177 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (gdata-&gt;VH1!=PETSC_NULL) {
<a name="l00178"></a>00178       nchars+=
<a name="l00179"></a>00179       snprintf(
<a name="l00180"></a>00180         wbufe+nchars,
<a name="l00181"></a>00181         nmax-(wbufe+nchars-wbufs),
<a name="l00182"></a>00182         <span class="stringliteral">&quot; %g %g %g&quot;</span>,
<a name="l00183"></a>00183         ta_vh1[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0]*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>,
<a name="l00184"></a>00184         ta_vh1[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1]*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>,
<a name="l00185"></a>00185         ta_vh1[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2]*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>
<a name="l00186"></a>00186       );
<a name="l00187"></a>00187     }
<a name="l00188"></a>00188     <span class="keywordflow">else</span> {
<a name="l00189"></a>00189       nchars+=
<a name="l00190"></a>00190       snprintf(
<a name="l00191"></a>00191         wbufe+nchars,
<a name="l00192"></a>00192         nmax-(wbufe+nchars-wbufs),
<a name="l00193"></a>00193         <span class="stringliteral">&quot; 0 0 0&quot;</span>
<a name="l00194"></a>00194       );
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196     <span class="keywordflow">if</span> (gdata-&gt;VH2!=PETSC_NULL) {
<a name="l00197"></a>00197       nchars+=
<a name="l00198"></a>00198       snprintf(
<a name="l00199"></a>00199         wbufe+nchars,
<a name="l00200"></a>00200         nmax-(wbufe+nchars-wbufs),
<a name="l00201"></a>00201         <span class="stringliteral">&quot; %g %g %g&quot;</span>,
<a name="l00202"></a>00202         ta_vh2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0]*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>,
<a name="l00203"></a>00203         ta_vh2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1]*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>,
<a name="l00204"></a>00204         ta_vh2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2]*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>
<a name="l00205"></a>00205       );
<a name="l00206"></a>00206     }
<a name="l00207"></a>00207     <span class="keywordflow">else</span> {
<a name="l00208"></a>00208       nchars+=
<a name="l00209"></a>00209       snprintf(
<a name="l00210"></a>00210         wbufe+nchars,
<a name="l00211"></a>00211         nmax-(wbufe+nchars-wbufs),
<a name="l00212"></a>00212         <span class="stringliteral">&quot; 0 0 0&quot;</span>
<a name="l00213"></a>00213       );
<a name="l00214"></a>00214     }
<a name="l00215"></a>00215     assert(NVDATA==10);
<a name="l00216"></a>00216 <span class="preprocessor">#else</span>
<a name="l00217"></a>00217 <span class="preprocessor"></span>    assert(NVDATA==4);
<a name="l00218"></a>00218 <span class="preprocessor">#endif</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span>    nchars+=
<a name="l00220"></a>00220     snprintf(
<a name="l00221"></a>00221       wbufe+nchars,
<a name="l00222"></a>00222       nmax-(wbufe+nchars-wbufs),
<a name="l00223"></a>00223       <span class="stringliteral">&quot;\n&quot;</span>
<a name="l00224"></a>00224     );
<a name="l00225"></a>00225 
<a name="l00226"></a>00226     <span class="comment">/* check for problems of snprintf */</span>
<a name="l00227"></a>00227     assert(nchars&gt;0);
<a name="l00228"></a>00228 
<a name="l00229"></a>00229     <span class="comment">/* update pointer to the end of the array */</span>
<a name="l00230"></a>00230     wbufe += nchars;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232     <span class="comment">/* check if we write beyond allocated area */</span>
<a name="l00233"></a>00233     assert(wbufe-wbufs &lt; nmax);
<a name="l00234"></a>00234   }
<a name="l00235"></a>00235   VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,&amp;ta_vvol);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00238"></a>00238 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (gdata-&gt;VH1!=PETSC_NULL) {
<a name="l00239"></a>00239     VecRestoreArray(gdata-&gt;VH1,&amp;ta_vh1);
<a name="l00240"></a>00240   }
<a name="l00241"></a>00241   <span class="keywordflow">if</span> (gdata-&gt;VH2!=PETSC_NULL) {
<a name="l00242"></a>00242     VecRestoreArray(gdata-&gt;VH2,&amp;ta_vh2);
<a name="l00243"></a>00243   }
<a name="l00244"></a>00244 <span class="preprocessor">#endif</span>
<a name="l00245"></a>00245 <span class="preprocessor"></span>
<a name="l00246"></a>00246   <a class="code" href="syncffprintf_8c.html#ad822d6c23d995cdca14184e56d559423">SynchronizedFastFPrintf</a>(fd,wbufe-wbufs,nmax,wbufs,PETSC_FALSE);
<a name="l00247"></a>00247   wbufe=wbufs;
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;%i&quot;</span>,<a class="code" href="writedataavs_8c.html#ae821231396164e33ec42f01e154f5e3c">NEDATA</a>);CHKERRQ(ierr);
<a name="l00251"></a>00251   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="writedataavs_8c.html#ae821231396164e33ec42f01e154f5e3c">NEDATA</a>;i++) {
<a name="l00252"></a>00252     ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot; 1&quot;</span>);CHKERRQ(ierr);
<a name="l00253"></a>00253   }
<a name="l00254"></a>00254   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;\n&quot;</span>);CHKERRQ(ierr);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;id, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00257"></a>00257   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;proc, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00258"></a>00258   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;vol, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00259"></a>00259   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;prop, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00260"></a>00260   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;a_x, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00261"></a>00261   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;a_y, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00262"></a>00262   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;a_z, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00263"></a>00263   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;K1, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00264"></a>00264   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;K2, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00265"></a>00265   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;Js, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00266"></a>00266   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,<span class="stringliteral">&quot;A, none\n&quot;</span>);CHKERRQ(ierr);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   PetscReal *ta_vol;
<a name="l00269"></a>00269   VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;ta_vol);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>; i++) {
<a name="l00272"></a>00272     <span class="keywordtype">int</span> nchars;
<a name="l00273"></a>00273     <span class="comment">/* write into buffer */</span>
<a name="l00274"></a>00274     nchars=
<a name="l00275"></a>00275     snprintf(
<a name="l00276"></a>00276       wbufe,
<a name="l00277"></a>00277       nmax-(wbufe-wbufs),
<a name="l00278"></a>00278       <span class="stringliteral">&quot;%i %i %i %g %i %g %g %g %g %g %g %g\n&quot;</span>,
<a name="l00279"></a>00279       gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i]+1,
<a name="l00280"></a>00280       gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i]+1,
<a name="l00281"></a>00281       rank,
<a name="l00282"></a>00282       PetscRealPart(ta_vol[i]),
<a name="l00283"></a>00283       gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+1,
<a name="l00284"></a>00284       sin(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+0])*cos(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+1]),
<a name="l00285"></a>00285       sin(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+0])*sin(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+1]),
<a name="l00286"></a>00286       cos(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+0]),
<a name="l00287"></a>00287       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+2],
<a name="l00288"></a>00288       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+3],
<a name="l00289"></a>00289       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+4],
<a name="l00290"></a>00290       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+5]
<a name="l00291"></a>00291     );
<a name="l00292"></a>00292     <span class="comment">/* check for problems of snprintf */</span>
<a name="l00293"></a>00293     assert(nchars&gt;0);
<a name="l00294"></a>00294 
<a name="l00295"></a>00295     <span class="comment">/* update pointer to the end of the array */</span>
<a name="l00296"></a>00296     wbufe += nchars;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298     <span class="comment">/* check if we write beyond allocated area */</span>
<a name="l00299"></a>00299     assert(wbufe-wbufs &lt; nmax);
<a name="l00300"></a>00300   }
<a name="l00301"></a>00301   VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;ta_vol);
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <a class="code" href="syncffprintf_8c.html#ad822d6c23d995cdca14184e56d559423">SynchronizedFastFPrintf</a>(fd,wbufe-wbufs,nmax,wbufs,PETSC_FALSE);
<a name="l00304"></a>00304   wbufe=wbufs;
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   ierr = PetscFree(wbufs);CHKERRQ(ierr);
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00311"></a>00311 }
<a name="l00312"></a>00312 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

